import { AppConfig, ContactScope, LifecycleMessage } from "@amazon-connect/workspace-types";
import { AmazonConnectApp } from "../amazon-connect-app";
import { AppStartHandler, AppStopHandler } from "./lifecycle-change";
import { StartSubscriptionOptions } from "./start-subscription-options";
type LifecycleAppState = {
    isRunning: true;
    appInstanceId: string;
    appConfig: AppConfig;
    contactScope?: ContactScope;
} | {
    isRunning: false;
    appInstanceId?: string;
    appConfig?: AppConfig;
    contactScope?: ContactScope;
};
export declare class LifecycleManager {
    private readonly provider;
    private readonly startHandlers;
    private readonly stopHandlers;
    private readonly state;
    private readonly logger;
    private isCreated;
    private isDestroyed;
    constructor(provider: AmazonConnectApp);
    handleLifecycleChangeMessage(msg: LifecycleMessage): Promise<void>;
    onStart(handler: AppStartHandler, options: StartSubscriptionOptions | undefined): void;
    onStop(handler: AppStopHandler): void;
    offStart(handler: AppStartHandler): void;
    offStop(handler: AppStopHandler): void;
    get appState(): LifecycleAppState;
    private handleCreate;
    private handleStart;
    private handleStop;
    private handleDestroy;
    private handleLifecycleChange;
    private getLifecycleChangeParams;
    private sendLifecycleHandlerCompletedMessage;
}
export {};
//# sourceMappingURL=lifecycle-manager.d.ts.map