import { AcknowledgeMessage, Proxy, SubscriptionHandlerData, SubscriptionTopic } from "@amazon-connect/core";
import { AppDownstreamMessage, AppMessageOrigin, AppUpstreamMessage } from "@amazon-connect/workspace-types";
import { AmazonConnectApp } from "../amazon-connect-app";
import { AmazonConnectAppConfig } from "../amazon-connect-app-config";
import { LifecycleManager } from "../lifecycle";
export declare class AppProxy extends Proxy<AmazonConnectAppConfig, AppUpstreamMessage, AppDownstreamMessage> {
    private readonly channel;
    private readonly lifecycleManager;
    private readonly appLogger;
    private connectionTimer;
    constructor(provider: AmazonConnectApp, lifecycleManager: LifecycleManager);
    get proxyType(): string;
    sendLifecycleHandlerCompleted(appInstanceId: string, stage: "create" | "destroy"): void;
    tryCloseApp(message: string | undefined, isFatalError?: boolean, data?: Record<string, unknown> | Error): void;
    publish(topic: SubscriptionTopic, data: SubscriptionHandlerData): void;
    protected initProxy(): void;
    protected sendMessageToSubject(message: AppUpstreamMessage): void;
    protected getUpstreamMessageOrigin(): AppMessageOrigin;
    protected handleConnectionAcknowledge(msg: AcknowledgeMessage): void;
    protected handleMessageFromSubject(msg: AppDownstreamMessage): void;
    private connectionTimeout;
    protected addContextToLogger(): Record<string, unknown>;
}
//# sourceMappingURL=app-proxy.d.ts.map