import { AmazonConnectProviderBase, ConnectLogData, SubscriptionHandler, SubscriptionHandlerData, SubscriptionTopic } from "@amazon-connect/core";
import { AmazonConnectAppConfig } from "./amazon-connect-app-config";
import { AppStartHandler, AppStopHandler, StartSubscriptionOptions } from "./lifecycle";
export declare class AmazonConnectApp extends AmazonConnectProviderBase<AmazonConnectAppConfig> {
    private readonly lifecycleManager;
    private readonly logger;
    constructor(config: AmazonConnectAppConfig);
    static init(config: AmazonConnectAppConfig): {
        provider: AmazonConnectApp;
    };
    static get default(): AmazonConnectApp;
    private createProxy;
    onStart(handler: AppStartHandler, options?: StartSubscriptionOptions): void;
    onStop(handler: AppStopHandler): void;
    offStart(handler: AppStartHandler): void;
    offStop(handler: AppStopHandler): void;
    sendCloseAppRequest(message?: string): void;
    sendError(message: string, data?: ConnectLogData): void;
    sendFatalError(message: string, data?: Record<string, unknown> | Error): void;
    subscribe<THandlerData extends SubscriptionHandlerData>(topic: SubscriptionTopic, handler: SubscriptionHandler<THandlerData>): void;
    unsubscribe<THandlerData extends SubscriptionHandlerData>(topic: SubscriptionTopic, handler: SubscriptionHandler<THandlerData>): void;
    publish<THandlerData extends SubscriptionHandlerData>(topic: SubscriptionTopic, data: THandlerData): void;
}
//# sourceMappingURL=amazon-connect-app.d.ts.map